/* Nome: 0000_GERFUNO_STRCOMP                                     */
/* Descrio:                                                     */
/* COMPARA DUAS STRINGS IGNORANDO O CASE (MAISCULAS, minsculas)
   E, OPCIONALMENTE, A EXISTNCIA DE ACENTOS E CEDILHA,
   DE ACORDO COM O 3 PARAM. DE ENTRADA:
   0 = IGNORA ACENTOS (DEFAULT)
   1 = CONSIDERA ACENTOS
   Sada:
   RETORNA 0 SE OS STRINGS FOREM IGUAIS E 1 SE DIFERENTES.        */

/* EXEMPLOS:
   STRCOMP('A', 'A')    = 0   (IGUAL)
   STRCOMP('A', '', 1) = 1   (DIFERENTE)
   STRCOMP('N', '')    = 0   (IGUAL)
   STRCOMP('  ', 'a  ') = 0 (IGUAL)
   STRCOMP('Cao Empanado', 'Cacao empanado') = 0 (IGUAL)
   STRCOMP('Almndegas de Peru', 'ALMONDEGAS DE PERU', 1) = 1 (DIFERENTE)
*/

/* Criao: Alexis
   Adaptao: Dmaso (28/10/2004)                                   */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'STRCOMP' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION STRCOMP
GO

CREATE FUNCTION STRCOMP
  (@P_STRING1 VARCHAR(255),
   @P_STRING2 VARCHAR(255),
   @P_IDIGNORESYMBOLS NUMERIC = 0) RETURNS NUMERIC
AS
BEGIN
   DECLARE @V_RESULT NUMERIC(1);
   DECLARE @V_POSTIL INT;
   DECLARE @OLD_TEXT VARCHAR(255);
   DECLARE @NEW_TEXT VARCHAR(255);

   SET @V_RESULT = 0;

   SET @OLD_TEXT = UPPER(@P_STRING1);
   SET @NEW_TEXT = UPPER(@P_STRING2);

   IF @P_IDIGNORESYMBOLS = 0 BEGIN
      /* TIRA OS ACENTOS DO PRIMEIRO STRING */
      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'C' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'Y' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @OLD_TEXT = SUBSTRING(@OLD_TEXT, 1, @V_POSTIL - 1) + 'N' + SUBSTRING(@OLD_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @OLD_TEXT);
      END;

      /* TIRA OS ACENTOS DO SEGUNDO STRING */

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'A' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'E' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'I' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'O' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'U' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'C' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'Y' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

      SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      WHILE (@V_POSTIL > 0) BEGIN
         SET @NEW_TEXT = SUBSTRING(@NEW_TEXT, 1, @V_POSTIL - 1) + 'N' + SUBSTRING(@NEW_TEXT, @V_POSTIL + 1, 255);
         SET @V_POSTIL = CHARINDEX('', @NEW_TEXT);
      END;

   END;

   IF (UPPER(LTRIM(RTRIM(@NEW_TEXT))) <> UPPER(LTRIM(RTRIM(@OLD_TEXT)))) BEGIN
      SET @V_RESULT = 1;
   END;
   RETURN(@V_RESULT);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'STRCOMP','4.05.103';
GO

